;(function($) {
$.fn.appleslider = function(options) {
	//オプションの読み込み
	var opts = $.extend({}, $.fn.appleslider.defaults, options);

	var thum = $('#thum', this);
	var btn = $('#btn', this);
	//ステージサイズ
	var stageW = $(this).outerWidth(true);
	//ステージセンター
	var stageCenter = stageW / 2;
	//サムネイル画像サイズ
	var imgW = $('img', thum).width();
	//画像の間隔
	var imgInterval = 25;
	//移動中のフラグ
	var moveFlug = false;
	//サムネイルulのサイズの配列
	var ulWidth = new Array();
	//現在表示しているリスト番号
	var thisNo = 0;
	
	//アクティブカーソルの位置の配列
	var activeCursor = new Array();
	
	//ulのサイズ取得
	$('ul', thum).each(function (i) {
		ulWidth[i] = 0;
		var lastUl = $('li', this).index();
		$('li', this).each(function (j) {
			if (lastUl != j )  ulWidth[i] += imgW + imgInterval;
			else ulWidth[i] += imgW;
		});
	});
	setListPosition(0);
	
	//最初のul以外を画面外に移動
	$('ul:not(:first) li', thum).css('left', stageW + imgInterval + 'px');
	
	//ボタンの位置を配列に入れる
	$('li', btn).each(function (i) {
		activeCursor[i] =  Math.floor($(this).position().left + ($(this).innerWidth()/2) - ($('#arrow').width()/2));
	});
	//アクティブカーソルを配置
	$('#arrow').css( 'left' , activeCursor[0] +'px');

	// ボタンをクリックしたら
	//==============================
	$('li', btn).click(function(){
		//クリックしたボタンが現在の番号＆アニメーション中だったら実行しない
		if (thisNo == $(this).index() || moveFlug == true) return;
		moveFlug = true;
		var nextNo = $(this).index();
		//終了地点
		var endPos = stageW + imgInterval;
		//移動は逆順
		var movList =  $($('ul:eq('+thisNo+') li', thum).get().reverse());
		//次の番号より小さかったら最初から移動
		if (thisNo < nextNo) {
			endPos = -imgW-imgInterval;
			movList = $('ul:eq('+thisNo+') li', thum);
		}
		var thumLength = $('ul:eq('+thisNo+') li', thum).index();
		//画面外に移動
		movList.each(function (i) {
			$(this).stop().delay(i*opts.delay).animate(
				{'left' : endPos+'px'},{
				duration: opts.speed,
				easing: 'easeInOutExpo',
				complete : function() {
					//最後だけ実行
					if (i == thumLength) {
						setListPosition(nextNo);
					}
				}
			});
		});
		//クリックしたボタンをアクティブにする
		$('li', btn).removeClass('active');
		$(this).addClass('active');
		var arrowPos = $(this).position().left + ($(this).innerWidth()/2) -7;
		$('#arrow').animate({
			'left' : activeCursor[nextNo] +'px'
		});
	});

	//画像を中心に配置する処理
	function setListPosition(nextNo) {
		var startPos = stageW;
		var listLeft =  0;
		var centerPos = stageCenter- (ulWidth[nextNo] / 2);
		var movList = $('ul:eq('+nextNo+') li', thum);
		if (thisNo > nextNo) {
			startPos = -imgW-imgInterval;
			movList =  $($('ul:eq('+nextNo+') li', thum).get().reverse());
			listLeft = ulWidth[nextNo] - imgW + imgInterval;
		}
		movList
		.css('left', startPos+'px')
		.each(function (i) {
			$(this).stop().delay(i*opts.delay).animate({
				'left': listLeft+centerPos + 'px'}, {
				duration: opts.speed+200,
				easing: 'easeOutBounce'
			});
			if (thisNo > nextNo) listLeft -= imgW + imgInterval;
			else listLeft += imgW + imgInterval;
		});
		thisNo = nextNo ;
		moveFlug = false;
	}
}
//デフォルトオプション
$.fn.appleslider.defaults = {
	speed: 400,
	delay: 100
};
})(jQuery);